#include <Windows.h>
#include "Render.h"
#include "Window.h"
#include "Vector2.h"
#include "Pixel.h"
#include "Texture.h"


Render::Render(Vector2<unsigned int> size)
{
	sign = new char[size.x * size.y];
	color = new WORD[size.x * size.y];

	this->size = new Vector2u(size);
}

Render::~Render()
{
	delete[] sign;
	delete[] color;
}

Pixel & Render::operator[](unsigned int position)
{
	return (Pixel &)( sign[position], color[position] );
}

void Render::clear()
{
	for(int i = 0; i < size->x * size->y; i++)
	{
		sign[i] = 0;
		color[i] = 0;
	}
}

void Render::update(Window * window)
{
	DWORD olog;
	WriteConsoleOutputCharacterA(*window->handle, sign, size->x * size->y, { 0, 2 }, &olog);
	WriteConsoleOutputAttribute(*window->handle, color, size->x * size->y, { 0, 2 }, &olog);
}

void Render::copy_texture(Vector2<unsigned int> position, Texture * texture, int rotate)
{
	if(texture == nullptr)
		return;
	if(rotate == 0)
		for(int j = 0; j < texture->sizeY; j++)
		{
			for(int i = 0; i < texture->sizeX; i++)
			{
				int index_t = i + j * texture->sizeX, index_r = position.x + i + ( position.y + j ) * size->x;
				if(texture->array[index_t].alpha)
				{
					sign[index_r] = texture->array[index_t].sign;
					color[index_r] = texture->array[index_t].color;
				}
			}
		}
	else if(rotate == 1)
		for(int j = 0, a = texture->sizeY; j < texture->sizeY; j++, --a)
		{
			for(int i = 0, b = texture->sizeX; i < texture->sizeX; i++, --b)
			{
				int index_t = b * texture->sizeX - a, index_r = position.x + i + ( position.y + j ) * size->x;
				if(texture->array[index_t].alpha)
				{
					sign[index_r] = texture->array[index_t].sign;
					color[index_r] = texture->array[index_t].color;
				}
			}
		}
	else if(rotate == 2)
		for(int j = 0, a = texture->sizeY; j < texture->sizeY; j++, --a)
		{
			for(int i = 0, b = texture->sizeX; i < texture->sizeX; i++, --b)
			{
				int index_t = a * texture->sizeX - b, index_r = position.x + i + ( position.y + j ) * size->x;
				if(texture->array[index_t].alpha)
				{
					sign[index_r] = texture->array[index_t].sign;
					color[index_r] = texture->array[index_t].color;
				}
			}
		}
	else if(rotate == 3)
		for(int j = 0; j < texture->sizeY; j++)
		{
			for(int i = 0, b = texture->sizeX; i < texture->sizeX; i++, --b)
			{
				int index_t = b * texture->sizeX - j - 1, index_r = position.x + i + ( position.y + j ) * size->x;
				if(texture->array[index_t].alpha)
				{
					sign[index_r] = texture->array[index_t].sign;
					color[index_r] = texture->array[index_t].color;
				}
			}
		}

}
