#include "Window.h"
#include "Vector2.h"
#include <Windows.h>

Window::Window(Vector2<unsigned int> size)
{
	this->size = new Vector2<unsigned int>(size);

	HWND hWnd = GetConsoleWindow();
	HMENU hm = GetSystemMenu(hWnd, FALSE);
	RemoveMenu(hm, SC_SIZE, MF_BYCOMMAND | MF_REMOVE);
	RemoveMenu(hm, SC_MAXIMIZE, MF_BYCOMMAND | MF_REMOVE);
	DrawMenuBar(hWnd);

	handle = new HANDLE(GetStdHandle(STD_OUTPUT_HANDLE));

	CONSOLE_FONT_INFOEX cfi;
	cfi.cbSize = sizeof(cfi);
	cfi.nFont = 0;
	cfi.dwFontSize.X = 5;
	cfi.dwFontSize.Y = 5;
	cfi.FontFamily = FF_DONTCARE;
	cfi.FontWeight = FW_NORMAL;

	SetCurrentConsoleFontEx(*handle, true, &cfi);

	SMALL_RECT a = { 0, 0, size.x - 1, size.y - 1 };
	SetConsoleWindowInfo(*handle, true, &a);
	SetConsoleWindowInfo(*handle, true, &a);
	SetConsoleScreenBufferSize(*handle, { (short)size.x, (short)size.y });
}

Window::~Window()
{
	delete handle;
	delete size;
}