#include "World.h"
#include <fstream>
#include "Block.h"
#include "Vector2.h"
#include "Texture.h"

World::World(Vector2<unsigned int> size, std::vector<Block> list)
{
	this->size = new Vector2u(size);
	array = new Block[( size.x * size.y )];
	this->list = list;
}

World::~World()
{
	delete[] array;
	delete size;
}

Block & World::get(Vector2<unsigned int> position)
{
	return array[position.x + position.y * size->x];
}

World::World(Vector2<unsigned int> size, std::vector<Block> list, char * path_file)
{
	this->size = new Vector2u(size);
	array = new Block[( size.x * size.y )];
	this->list = list;	load_from_file(path_file);
}

void World::load_from_file(char * path_file)
{
	std::ifstream file((std::string)path_file + ".block_list");

	for(int i = 0; i < ( size->x * size->y ); i++)
	{
		array[i] = list[file.get()];
	}
}